"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.percentage = exports.pow = exports.mod = exports.max = exports.min = void 0;

var _VariableNode = _interopRequireDefault(require("../tree/VariableNode"));

var _convert = require("../tree/convert");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var min = function min() {
  var min = function min(arr) {
    return arr[arr.reduce(function (iMax, x, i) {
      return parseFloat(x) < parseFloat(arr[iMax]) ? i : iMax;
    }, 0)];
  };

  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return new _VariableNode["default"]("(".concat(min, ")([").concat(args.map(function (a) {
    return (0, _convert.convertNode)(a);
  }).join(", "), "])"));
};

exports.min = min;

var max = function max() {
  var max = function max(arr) {
    return arr[arr.reduce(function (iMax, x, i) {
      return parseFloat(x) > parseFloat(arr[iMax]) ? i : iMax;
    }, 0)];
  };

  for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    args[_key2] = arguments[_key2];
  }

  return new _VariableNode["default"]("(".concat(max, ")([").concat(args.map(function (a) {
    return (0, _convert.convertNode)(a);
  }).join(", "), "])"));
};

exports.max = max;

var mod = function mod(x, y) {
  var apply = function apply(x, y) {
    return parseFloat(x) % parseFloat(y) + ('' + x).replace(/[\d.-]*/, "");
  };

  return new _VariableNode["default"]("(".concat(apply, ")(").concat((0, _convert.convertNode)(x), ", ").concat((0, _convert.convertNode)(y), ")"));
};

exports.mod = mod;

var pow = function pow(x, y) {
  var apply = function apply(x, y) {
    return Math.pow(parseFloat(x), parseFloat(y)) + ('' + x).replace(/[\d.-]*/, "");
  };

  return new _VariableNode["default"]("(".concat(apply, ")(").concat((0, _convert.convertNode)(x), ", ").concat((0, _convert.convertNode)(y), ")"));
};

exports.pow = pow;

var percentage = function percentage(value) {
  return new _VariableNode["default"]("(parseFloat(".concat((0, _convert.convertNode)(value), ") * 100) + \"%\""));
};

exports.percentage = percentage;