"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isem = exports.ispercentage = exports.ispixel = exports.isstring = exports.isnumber = exports.iscolor = void 0;

var _VariableNode = _interopRequireDefault(require("../tree/VariableNode"));

var _convert = require("../tree/convert");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var iscolor = function iscolor(value) {
  return new _VariableNode["default"]("require('tinycolor2')(".concat((0, _convert.convertNode)(value), ").isValid().toString()"));
};

exports.iscolor = iscolor;

var isnumber = function isnumber(value) {
  return new _VariableNode["default"]("(!isNaN(parseFloat(".concat((0, _convert.convertNode)(value), "))).toString()"));
};

exports.isnumber = isnumber;

var isstring = function isstring(value) {
  return new _VariableNode["default"]("(('' + ".concat((0, _convert.convertNode)(value), ")[0] === '\"').toString()"));
};

exports.isstring = isstring;

var ispixel = function ispixel(value) {
  return new _VariableNode["default"]("(('' + ".concat((0, _convert.convertNode)(value), ").endsWith(\"px\")).toString()"));
};

exports.ispixel = ispixel;

var ispercentage = function ispercentage(value) {
  return new _VariableNode["default"]("(('' + ".concat((0, _convert.convertNode)(value), ").endsWith(\"%\")).toString()"));
};

exports.ispercentage = ispercentage;

var isem = function isem(value) {
  return new _VariableNode["default"]("(('' + ".concat((0, _convert.convertNode)(value), ").endsWith(\"em\")).toString()"));
};

exports.isem = isem;