"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _convert = require("./convert");

var _VariableNode = _interopRequireDefault(require("./VariableNode"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Condition =
/*#__PURE__*/
function () {
  function Condition(op, l, r, i, negate) {
    _classCallCheck(this, Condition);

    this.op = op.trim();
    this.lvalue = l;
    this.rvalue = r;
    this._index = i;
    this.negate = negate;
  }

  _createClass(Condition, [{
    key: "accept",
    value: function accept(visitor) {
      this.lvalue = visitor.visit(this.lvalue);
      this.rvalue = visitor.visit(this.rvalue);
    }
  }, {
    key: "eval",
    value: function _eval(context) {
      var a = this.lvalue.eval(context);
      var b = this.rvalue.eval(context);
      a = a.value ? a.value : (0, _convert.convertNode)(a);
      b = b.value ? b.value : (0, _convert.convertNode)(b);
      var result;

      switch (this.op) {
        case 'and':
          result = "".concat(a, " && ").concat(b);
          break;

        case 'or':
          result = "".concat(a, " || ").concat(b);
          break;

        case '=':
          if (b === "true") {
            result = "!!".concat(a);
          } else {
            result = "".concat(a, " == ").concat(b);
          }

          break;

        default:
          result = "".concat(a, " ").concat(this.op, " ").concat(b);
          break;
      }

      if (this.negate) {
        return new _VariableNode["default"]("!".concat(result));
      } else {
        return new _VariableNode["default"](result);
      }
    }
  }]);

  return Condition;
}();

exports["default"] = Condition;