"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.convertNode = exports["default"] = void 0;

var _VariableNode = _interopRequireDefault(require("./VariableNode"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var varRgx = /^[@$]/;

var _default = function _default(val, defaultValue) {
  if (val === undefined) return val;

  if (!('' + val).startsWith("@")) {
    return "\"".concat(val, "\"");
  }

  val = val.replace(varRgx, '');
  var parts = ["props[\"".concat(val, "\"]"), "(props.theme || {})[\"".concat(val, "\"]"), defaultValue];
  return "[".concat(parts.filter(function (v) {
    return !!v;
  }).join(","), "].filter(v => v !== void 0)[0]");
};

exports["default"] = _default;

var convertNode = function convertNode(v) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      cssFragment = _ref.cssFragment;

  if (!v) return undefined;
  var value = v.toCSS ? v.toCSS({
    cssFragment: cssFragment
  }) : v.toString();

  if (v instanceof _VariableNode["default"]) {
    return value;
  } // Deals with "strings"


  if (value.startsWith('`')) {
    return value;
  }

  return "`".concat(value, "`");
};

exports.convertNode = convertNode;