"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _detectors = require("../utils/detectors");

var _transpileLess = _interopRequireDefault(require("./transpileLess"));

var _generator = _interopRequireDefault(require("@babel/generator"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var regex = /`([\s\S]*)`/;

var _default = function _default(path, state, _ref) {
  var t = _ref.types;

  if (!((0, _detectors.isStyled)(t)(path.node.tag, state) || (0, _detectors.isPureHelper)(t)(path.node.tag || path.node.callee, state))) {
    return;
  } // Find the TemplateLiteral in the TaggedTemplateExpression


  path.traverse({
    TemplateLiteral: function TemplateLiteral(p) {
      if (p.isClean) return;
      p.stop(); // Only traverse the first TemplateLiteral of TaggedTemplateExpression

      var rawSource = p.getSource();

      if (!rawSource) {
        var _generate = (0, _generator["default"])({
          type: 'Program',
          body: [path.node]
        }),
            code = _generate.code;

        rawSource = code;
      }

      var _regex$exec = regex.exec(rawSource),
          _regex$exec2 = _slicedToArray(_regex$exec, 2),
          foo = _regex$exec2[0],
          source = _regex$exec2[1];

      if (!source) return;
      p.isClean = true;

      try {
        var raw = (0, _transpileLess["default"])(source, state.file.opts.filename, state.opts);

        if (source !== raw) {
          p.replaceWithSourceString('`' + raw + '`');
        }
      } catch (e) {
        console.error("Error converting the less syntax for the file:", state.file.opts.filename, rawSource, e);
      }
    }
  });
};

exports["default"] = _default;